'use strict';

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

const async = require('async');
//const Backoff = require('backoff');

var _require = require('await-to-js');

const to = _require.to;


class QueueManager {
  constructor(options = {}) {
    this._queue = async.queue(this._work, 1);
  }

  _work(item, cb) {
    var _this = this;

    return _asyncToGenerator(function* () {
      var _ref = yield to(item.fn()),
          _ref2 = _slicedToArray(_ref, 2);

      const error = _ref2[0],
            result = _ref2[1];


      if (error && error.code === 'ECONN') {
        _this._work(item);
      } else cb(error, result);
    })();
  }

  pushCommand(fn, options, cb) {
    const work = {
      fn,
      options
    };

    this._queue.push(work, cb);
  }
}

module.exports = QueueManager;